# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/03.config.messenger.ipynb.

# %% auto 0
__all__ = ['CANMessenger', 'TripMessenger', 'can_server_list', 'can_servers_by_name', 'can_servers_by_host', 'trip_server_list',
           'trip_servers_by_name', 'trip_servers_by_host']

# %% ../../nbs/03.config.messenger.ipynb 2
from collections import namedtuple

# %% ../../nbs/03.config.messenger.ipynb 4
CANMessenger = namedtuple(
    "CANMessenger",
    [
        "server_name",  # name of the can server
        "host",  # url for the can server
        "port",  # port for the can server
        "protocol",  # protocol for the can server, for now either "udp" or "tcp"
    ],  # "protocol" is used to differentiate between the two modes of communication "cloud" or "local"
)

# %% ../../nbs/03.config.messenger.ipynb 6
TripMessenger = namedtuple(
    "TripMessenger",
    [
        "server_name",  # name of the trip contol hmi server
        "host",  # url for the trip server
        "port",  # port for the trip server
        "protocol",  # port for the trip server
    ],
)

# %% ../../nbs/03.config.messenger.ipynb 8
can_server_list = [
    CANMessenger(
        server_name="can_intra",  # name of the can server
        host="10.0.64.78",  # url for the database server
        port="5000",  # port for the database server
        protocol="tcp",
    ),
    CANMessenger(
        server_name="can_cloud",  # name of the database
        host="10.10.0.6",  # url for the database server
        port="30865",  # port for the database server
        protocol="tcp",
    ),
    CANMessenger(
        server_name="can_cloud_svc",  # name of the database
        host="remotecan.veos",  # url for the database server
        port="5000",  # port for the database server
        protocol="tcp",
    ),
    CANMessenger(
        server_name="can_udp_svc",  # name of the database
        host="127.0.0.1",  # url for the database server
        port="8002",  # port for the database server
        protocol="udp",
    ),
]

# %% ../../nbs/03.config.messenger.ipynb 10
can_servers_by_name = dict(
    zip([srv.server_name for srv in can_server_list], can_server_list)
)

# %% ../../nbs/03.config.messenger.ipynb 12
can_servers_by_host = dict(zip([srv.host for srv in can_server_list], can_server_list))

# %% ../../nbs/03.config.messenger.ipynb 14
trip_server_list = [
    TripMessenger(
        server_name="rocket_intra",  # name of the database
        host="10.0.64.78",  # url for the database server
        port="9876",  # port for the database server
        protocol="tcp",
    ),
    TripMessenger(
        server_name="rocket_cloud",  # name of the database
        host="10.0.64.122",  # url for the database server
        port="9876",  # port for the database server
        protocol="tcp",
    ),
    TripMessenger(
        server_name="rocket_cluster",  # name of the database
        host="10.10.0.13",  # url for the database server
        port="9876",  # port for the database server
        protocol="tcp",
    ),
    TripMessenger(
        server_name="local_udp",  # name of the database
        host="127.0.0.1",  # url for the database server
        port="8002",  # port for the database server
        protocol="udp",
    ),
]

# %% ../../nbs/03.config.messenger.ipynb 16
trip_servers_by_name = dict(
    zip([srv.server_name for srv in trip_server_list], trip_server_list)
)

# %% ../../nbs/03.config.messenger.ipynb 18
trip_servers_by_host = dict(
    zip([srv.host for srv in trip_server_list], trip_server_list)
)
