# AUTOGENERATED! DO NOT EDIT! File to edit: ../../../nbs/06.dataflow.pipeline.deque.ipynb.

# %% auto 0
__all__ = ['T', 'PipelineDQ']

# %% ../../../nbs/06.dataflow.pipeline.deque.ipynb 3
from collections import deque
from typing import TypeVar

# %% ../../../nbs/06.dataflow.pipeline.deque.ipynb 4
T = TypeVar("T")  # Generic type

# %% ../../../nbs/06.dataflow.pipeline.deque.ipynb 5
class PipelineDQ(deque[T]):
    """Pipeline with Deque for double-ended processing unit in dataflow"""

    def get_data(self) -> T:
        """
        Get data from the pipeline

        return:
            data: data from the pipeline
        """
        return self.pop()

    def put_data(self, value: T):
        """
        Put data into the pipeline

        arg:

            value: data to be put into the pipeline

        return:

            None
        """

        self.append(value)

    def clear(self):
        """
        clear the pipeline (Deque)

        `collection.deque` has a clear method. Just call it.
        """
        self.clear()
